/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.32 Revision 1.44
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.32 2006/09/10 10:29:21 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.44 2007/04/23 07:17:42 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
38# 38#
39# If ${VDR_RCADDON_FILE} is set install this file 39# If ${VDR_RCADDON_FILE} is set install this file
40# else install ${FILESDIR}/rc-addon.sh if it exists. 40# else install ${FILESDIR}/rc-addon.sh if it exists.
41# 41#
42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh 42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
43# (in example vdr-femon this would be /usr/lib/vdr/rcscript/plugin-femon.sh) 43# (in example vdr-femon this would be /usr/share/vdr/rcscript/plugin-femon.sh)
44# 44#
45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr 45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
46# It could be used for special startup actions for this plugins, or to create the 46# It could be used for special startup actions for this plugins, or to create the
47# plugin command line options from a nicer version of a conf.d file. 47# plugin command line options from a nicer version of a conf.d file.
48 48
58# all patches which ending on diff or patch in this DIR will automatically applied 58# all patches which ending on diff or patch in this DIR will automatically applied
59# 59#
60 60
61inherit base multilib eutils flag-o-matic 61inherit base multilib eutils flag-o-matic
62 62
63IUSE="debug" 63IUSE=""
64 64
65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
66VDRPLUGIN="${PN/#vdrplugin-/}" 66VDRPLUGIN="${PN/#vdrplugin-/}"
67VDRPLUGIN="${VDRPLUGIN/#vdr-/}" 67VDRPLUGIN="${VDRPLUGIN/#vdr-/}"
68VDRPLUGIN="${VDRPLUGIN/%-cvs/}" 68VDRPLUGIN="${VDRPLUGIN/%-cvs/}"
98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb." 98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb 99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
100 fi 100 fi
101} 101}
102 102
103# New method of storing plugindb
104# Called from src_install
105# file maintained by normal portage-methods
106create_plugindb_file() {
107 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
108 local DB_FILE=${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}
109 insinto ${NEW_VDRPLUGINDB_DIR}
110 cat <<-EOT > ${D}/${DB_FILE}
111 VDRPLUGIN_DB=1
112 CREATOR=ECLASS
113 EBUILD=${CATEGORY}/${PN}
114 EBUILD_V=${PVR}
115 EOT
116}
117
118# Delete files created outside of vdr-plugin.eclass
119# vdrplugin-rebuild.ebuild converted plugindb and files are
120# not deleted by portage itself - should only be needed as
121# long as not every system has switched over to
122# vdrplugin-rebuild-0.2
123delete_orphan_plugindb_file() {
124 #elog Testing for orphaned plugindb file
125 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
126 local DB_FILE=${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}
127
128 # file exists
129 [[ -f ${DB_FILE} ]] || return
130
131 # will portage handle the file itself
132 if grep -q CREATOR=ECLASS ${DB_FILE}; then
133 #elog file owned by eclass - don't touch it
134 return
135 fi
136
137 elog "Removing orphaned plugindb-file."
138 elog "\t#rm ${DB_FILE}"
139 rm ${DB_FILE}
140}
141
103vdr-plugin_pkg_setup() { 142vdr-plugin_pkg_setup() {
104 # -fPIC is needed for shared objects on some platforms (amd64 and others) 143 # -fPIC is needed for shared objects on some platforms (amd64 and others)
105 append-flags -fPIC 144 append-flags -fPIC
106 use debug && append-flags -g
107 145
108 # Where should the plugins live in the filesystem 146 # Where should the plugins live in the filesystem
109 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins" 147 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
110 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums" 148 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
111 149
112 # transition to /usr/share/... will need new vdr-scripts version stable 150 # was /usr/lib/... some time ago
151 # since gentoo-vdr-scripts-0.3.6 it works with /usr/share/...
113 VDR_RC_DIR="/usr/lib/vdr/rcscript" 152 VDR_RC_DIR="/usr/share/vdr/rcscript"
114 153
115 # Pathes to includes 154 # Pathes to includes
116 VDR_INCLUDE_DIR="/usr/include/vdr" 155 VDR_INCLUDE_DIR="/usr/include/vdr"
117 DVB_INCLUDE_DIR="/usr/include" 156 DVB_INCLUDE_DIR="/usr/include"
118 157
136 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile 175 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile
137 176
138 while [ "$1" ]; do 177 while [ "$1" ]; do
139 178
140 case "$1" in 179 case "$1" in
180 all_but_unpack)
181 vdr-plugin_src_unpack add_local_patch patchmakefile
182 ;;
141 unpack) 183 unpack)
142 base_src_unpack 184 base_src_unpack
143 ;; 185 ;;
144 patchmakefile) 186 patchmakefile)
145 if ! cd ${S}; then 187 if ! cd ${S}; then
146 ewarn "There seems to be no plugin-directory with the name ${S##*/}" 188 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
147 ewarn "Perhaps you find one among these:" 189 ewarn "Perhaps you find one among these:"
148 cd "${WORKDIR}" 190 cd "${WORKDIR}"
149 einfo "$(/bin/ls -1 ${WORKDIR})" 191 ewarn "$(/bin/ls -1 ${WORKDIR})"
150 die "Could not change to plugin-source-directory!" 192 die "Could not change to plugin-source-directory!"
151 fi 193 fi
152 194
153 einfo "Patching Makefile" 195 einfo "Patching Makefile"
154 [[ -e Makefile ]] || die "Makefile of plugin can not be found!" 196 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
173 -e 's:^APIVERSION = :APIVERSION ?= :' \ 215 -e 's:^APIVERSION = :APIVERSION ?= :' \
174 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \ 216 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
175 -e '2i\APIVERSION = '"${APIVERSION}" 217 -e '2i\APIVERSION = '"${APIVERSION}"
176 eend $? 218 eend $?
177 219
178 ebegin " Correcting CXXFLAGS" 220 ebegin " Correcting Compile-Flags"
179 sed -i Makefile \ 221 sed -i Makefile \
180 -e 's:^CXXFLAGS:#CXXFLAGS:' 222 -e 's:^CXXFLAGS:#CXXFLAGS:' \
223 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
181 eend $? 224 eend $?
182 225
183 ebegin " Disabling file stripping" 226 ebegin " Disabling file stripping"
184 sed -i Makefile \ 227 sed -i Makefile \
185 -e '/@.*strip/d' \ 228 -e '/@.*strip/d' \
186 -e '/strip \$(LIBDIR)\/\$@/d' \ 229 -e '/strip \$(LIBDIR)\/\$@/d' \
187 -e '/^STRIP =/d' \ 230 -e '/^STRIP =/d' \
188 -e '/@.*\$(STRIP)/d' 231 -e '/@.*\$(STRIP)/d'
189 eend $? 232 eend $?
190 PLUGIN_MAKEFILE_PATCHED=1 233
234 # Use a file instead of an variable as single-stepping via ebuild
235 # destroys environment.
236 touch ${WORKDIR}/.vdr-plugin_makefile_patched
191 ;; 237 ;;
192 add_local_patch) 238 add_local_patch)
193 cd ${S} 239 cd ${S}
194 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then 240 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
195 echo 241 echo
235 case "$1" in 281 case "$1" in
236 prepare) 282 prepare)
237 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 283 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
238 ;; 284 ;;
239 compile) 285 compile)
240 if [[ -z ${PLUGIN_MAKEFILE_PATCHED} ]]; then 286 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
241 eerror "Wrong use of vdr-plugin.eclass." 287 eerror "Wrong use of vdr-plugin.eclass."
242 eerror "An ebuild for a vdr-plugin will not work without" 288 eerror "An ebuild for a vdr-plugin will not work without"
243 eerror "calling vdr-plugin_src_unpack to patch the Makefile." 289 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
244 echo 290 echo
245 eerror "Please report this at bugs.gentoo.org." 291 eerror "Please report this at bugs.gentoo.org."
286 332
287 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it 333 # if VDR_CONFD_FILE is empty and ${FILESDIR}/confd exists take it
288 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd 334 [[ -z ${VDR_CONFD_FILE} ]] && [[ -e ${FILESDIR}/confd ]] && VDR_CONFD_FILE=${FILESDIR}/confd
289 335
290 if [[ -n ${VDR_CONFD_FILE} ]]; then 336 if [[ -n ${VDR_CONFD_FILE} ]]; then
291 insinto /etc/conf.d
292 newins "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN} 337 newconfd "${VDR_CONFD_FILE}" vdr.${VDRPLUGIN}
293 fi 338 fi
294 339
295 340
296 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it 341 # if VDR_RCADDON_FILE is empty and ${FILESDIR}/rc-addon.sh exists take it
297 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh 342 [[ -z ${VDR_RCADDON_FILE} ]] && [[ -e ${FILESDIR}/rc-addon.sh ]] && VDR_RCADDON_FILE=${FILESDIR}/rc-addon.sh
301 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 346 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
302 fi 347 fi
303 348
304 349
305 350
351 # Danger: Not using $ROOT here, as compile will also not use it !!!
352 # If vdr in $ROOT and / differ, plugins will not run anyway
353
306 insinto ${VDR_CHECKSUM_DIR} 354 insinto ${VDR_CHECKSUM_DIR}
307 if [[ -f ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 355 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
308 newins ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN} 356 newins ${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}
309 else 357 else
310 if which md5sum >/dev/null 2>&1; then 358 if type -p md5sum >/dev/null 2>&1; then
311 cd ${S} 359 cd ${S}
312 ( 360 (
313 cd ${ROOT}${VDR_INCLUDE_DIR} 361 cd ${VDR_INCLUDE_DIR}
314 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2 362 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
315 ) > header-md5-${PN} 363 ) > header-md5-${PN}
316 doins header-md5-${PN} 364 doins header-md5-${PN}
317 fi 365 fi
318 fi 366 fi
367
368 create_plugindb_file
319} 369}
320 370
321vdr-plugin_pkg_postinst() { 371vdr-plugin_pkg_postinst() {
372 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
322 update_vdrplugindb 373 update_vdrplugindb
323 einfo 374 fi
375 elog
324 einfo "The vdr plugin ${VDRPLUGIN} has now been installed." 376 elog "The vdr plugin ${VDRPLUGIN} has now been installed."
325 einfo "To activate execute the following command:" 377 elog "To activate execute the following command:"
326 einfo 378 elog
327 einfo " emerge --config ${PN}" 379 elog " emerge --config ${PN}"
328 einfo 380 elog
329 if [[ -n "${VDR_CONFD_FILE}" ]]; then 381 if [[ -n "${VDR_CONFD_FILE}" ]]; then
330 einfo "And have a look at the config-file" 382 elog "And have a look at the config-file"
331 einfo "/etc/conf.d/vdr.${VDRPLUGIN}" 383 elog "/etc/conf.d/vdr.${VDRPLUGIN}"
332 einfo 384 elog
333 fi 385 fi
334} 386}
335 387
336vdr-plugin_pkg_postrm() { 388vdr-plugin_pkg_postrm() {
389 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
337 remove_vdrplugindb 390 remove_vdrplugindb
391 fi
392 delete_orphan_plugindb_file
338} 393}
339 394
340vdr-plugin_pkg_config_final() { 395vdr-plugin_pkg_config_final() {
341 diff ${conf_orig} ${conf} 396 diff ${conf_orig} ${conf}
342 rm ${conf_orig} 397 rm ${conf_orig}
343} 398}
344 399
345vdr-plugin_pkg_config() { 400vdr-plugin_pkg_config_old() {
401 elog "Using interface of gentoo-vdr-scripts-0.3.6 and older"
346 if [[ -z "${INSTALLPLUGIN}" ]]; then 402 if [[ -z "${INSTALLPLUGIN}" ]]; then
347 INSTALLPLUGIN="${VDRPLUGIN}" 403 INSTALLPLUGIN="${VDRPLUGIN}"
348 fi 404 fi
349 # First test if plugin is already inside PLUGINS 405 # First test if plugin is already inside PLUGINS
350 local conf=/etc/conf.d/vdr 406 local conf=/etc/conf.d/vdr
351 conf_orig=${conf}.before_emerge_config 407 conf_orig=${conf}.before_emerge_config
352 cp ${conf} ${conf_orig} 408 cp ${conf} ${conf_orig}
353 409
354 einfo "Reading ${conf}" 410 elog "Reading ${conf}"
355 if ! grep -q "^PLUGINS=" ${conf}; then 411 if ! grep -q "^PLUGINS=" ${conf}; then
356 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1) 412 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
357 if [[ -n "${LINE}" ]]; then 413 if [[ -n "${LINE}" ]]; then
358 sed -e ${LINE}'a PLUGINS=""' -i ${conf} 414 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
359 else 415 else
372 break; 428 break;
373 fi 429 fi
374 done 430 done
375 431
376 if [[ "${active}" == "1" ]]; then 432 if [[ "${active}" == "1" ]]; then
377 einfo "${INSTALLPLUGIN} already activated" 433 elog "${INSTALLPLUGIN} already activated"
378 echo 434 echo
379 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer 435 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
380 if [[ "${answer}" != "yes" ]]; then 436 if [[ "${answer}" != "yes" ]]; then
381 einfo "aborted" 437 elog "aborted"
382 return 438 return
383 fi 439 fi
384 einfo "Removing ${INSTALLPLUGIN} from active plugins." 440 elog "Removing ${INSTALLPLUGIN} from active plugins."
385 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1) 441 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
386 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \ 442 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
387 -e ${LINE}'s/ \( \)*/ /g' \ 443 -e ${LINE}'s/ \( \)*/ /g' \
388 -e ${LINE}'s/ "/"/g' \ 444 -e ${LINE}'s/ "/"/g' \
389 -e ${LINE}'s/" /"/g' 445 -e ${LINE}'s/" /"/g'
391 vdr-plugin_pkg_config_final 447 vdr-plugin_pkg_config_final
392 return 448 return
393 fi 449 fi
394 450
395 451
396 einfo "Adding ${INSTALLPLUGIN} to active plugins." 452 elog "Adding ${INSTALLPLUGIN} to active plugins."
397 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1) 453 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
398 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \ 454 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
399 -e ${LINE}'s/ \( \)*/ /g' \ 455 -e ${LINE}'s/ \( \)*/ /g' \
400 -e ${LINE}'s/ "/"/g' \ 456 -e ${LINE}'s/ "/"/g' \
401 -e ${LINE}'s/" /"/g' 457 -e ${LINE}'s/" /"/g'
402 458
403 vdr-plugin_pkg_config_final 459 vdr-plugin_pkg_config_final
460}
461
462vdr-plugin_pkg_config_new() {
463 elog "Using interface introduced with gentoo-vdr-scripts-0.3.7"
464 if [[ -z "${INSTALLPLUGIN}" ]]; then
465 INSTALLPLUGIN="${VDRPLUGIN}"
466 fi
467
468 active=0
469 # First test if plugin is already inside PLUGINS
470 local conf=/etc/conf.d/vdr.plugins
471 exec 3<${conf}
472 while read -u 3 line; do
473 [[ ${line} == "" ]] && continue
474 [[ ${line:0:1} == "#" ]] && continue
475 set -- ${line}
476 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
477 done
478 exec 3<&-
479
480 if [[ $active == 0 ]]; then
481 elog "Adding ${INSTALLPLUGIN} to active plugins."
482
483 # The pure edit process.
484 echo "${INSTALLPLUGIN}" >> "${conf}"
485 else
486 elog "${INSTALLPLUGIN} already activated"
487 echo
488 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
489 if [[ "${answer}" != "yes" ]]; then
490 elog "aborted"
491 return
492 fi
493 elog "Removing ${INSTALLPLUGIN} from active plugins."
494
495 # The pure edit process
496 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
497 fi
498}
499
500vdr-plugin_pkg_config() {
501 if has_version ">media-tv/gentoo-vdr-scripts-0.3.6"; then
502 vdr-plugin_pkg_config_new
503 else
504 vdr-plugin_pkg_config_old
505 fi
404} 506}
405 507
406fix_vdr_libsi_include() 508fix_vdr_libsi_include()
407{ 509{
408 einfo "Fixing include of libsi-headers" 510 einfo "Fixing include of libsi-headers"

Legend:
Removed from v.1.32  
changed lines
  Added in v.1.44

  ViewVC Help
Powered by ViewVC 1.1.20